//--------------------------------------------------------------
// File     : main.c
// Datum    : 17.06.2015
// Version  : 1.0
// Autor    : UB
// EMail    : mc-4u(@)t-online.de
// Web      : www.mikrocontroller-4u.de
// CPU      : STM32F429
// Board    : STM32F429-Board von UB (Version 1.0)
// IDE      : CooCox CoIDE 1.7.4
// GCC      : 4.7 2012q4
// Module   : CMSIS_BOOT, M4_CMSIS_CORE
// Funktion : Hauptprogramm
// Hinweis  : Diese zwei Files muessen auf 8MHz stehen
//              "cmsis_boot/stm32f4xx.h"
//              "cmsis_boot/system_stm32f4xx.c"
// In Configuration diese Define hinzufgen :
// "STM32F429_439xx" , "__ASSEMBLY__" , "USE_STDPERIPH_DRIVER"
//--------------------------------------------------------------
// Beschreibung :
// LoLevel-Test vom eigenbau STM32F429-Board von UB (Version 1.0)
//
// Check vom 4Wire-Touch
//--------------------------------------------------------------

#include "main.h"
#include "stm32_ub_systick.h"
#include "stm32_ub_uart.h"
#include <stdio.h>
#include "stm32_ub_lcd_480x272.h"
#include "stm32_ub_touch_480x272.h"


//----------------------------------------------------------------------
// gefuelltes Rechteck zeichnen
// (im RGB-Farbraum)
//----------------------------------------------------------------------
void fillrect(uint16_t xp, uint16_t yp, uint16_t w, uint16_t h, uint16_t c)
{
  uint16_t x,y;

  for(y=0;y<h;y++) {
    for(x=0;x<w;x++) {
      UB_LCD_SetCursor2Draw(xp+x,yp+y);
      UB_LCD_DrawPixel(c);
    }
  }
}


//----------------------------------------------------------------------
int main(void)
{
  SystemInit(); // Quarz Einstellungen aktivieren

  // init vom sytsick
  UB_Systick_Init();

  // init der uart
  UB_Uart_Init();

  UB_Systick_Pause_ms(500);

  // powerOn string
  UB_Uart_SendString(COM6,"F429-Board",CRLF);
  UB_Uart_SendString(COM6,"TFT-Touch-Check",CRLF);
  UB_Uart_SendString(COM6," ",CRLF);
  UB_Systick_Pause_ms(500);


  // init vom LCD
  UB_LCD_Init();
  // auf FullScreen
  UB_LCD_LayerInit_Fullscreen();

  // auf Layer-2 schalten
  UB_LCD_SetLayer_2();
  // mit weiss fuellen
  UB_LCD_FillLayer(RGB_COL_WHITE);

  // init vom Touch
  UB_Touch_Init();

  UB_Uart_SendString(COM6,"ready",CRLF);

  while(1) {
    UB_Systick_Pause_ms(30);
    if(Touch_Data.status==TOUCH_PRESSED) {
      fillrect(Touch_Data.xp,Touch_Data.yp,5,5,RGB_COL_RED);
    }
  }
}

